/*
 * TJUGens.scala
 * (ScalaCollider-UGens)
 *
 * This is a synthetically generated file.
 * Created: Sat Sep 24 02:12:30 CEST 2011
 * ScalaCollider-UGens version: 0.14-SNAPSHOT
 */

package de.sciss.synth
package ugen
import collection.immutable.{IndexedSeq => IIdxSeq}
import aux.UGenHelper._
/**
 * A digital filter UGen which aims at accurately modeling an analog filter.
 * It provides low-pass and high-pass modes, and the filter can be overdriven and will
 * self-oscillate at high resonances.
 */
object DFM1 {
   
   /**
    * @param in              Input signal to filter.
    * @param freq            Cutoff frequency in Hertz.
    * @param res             Resonance of the filter. Resonance is minimal at `0.0` and high at `1.0`,
    *                        above which the filter starts overdrive and sound saturated (e.g. `1.2`).
    * @param gain            Linear gain applied to the input signal.
    * @param mode            The filter can be used in lowpass (`0`) or highpass (`1`) mode.
    * @param noise           Amount (amplitude) of noise added to the model.
    */
   def ar(in: GE, freq: GE = 440.0f, res: GE = 0.1f, gain: GE = 1.0f, mode: GE = 0.0f, noise: GE = 3.0E-4f) = apply(audio, in, freq, res, gain, mode, noise)
}
/**
 * A digital filter UGen which aims at accurately modeling an analog filter.
 * It provides low-pass and high-pass modes, and the filter can be overdriven and will
 * self-oscillate at high resonances.
 * 
 * @param in              Input signal to filter.
 * @param freq            Cutoff frequency in Hertz.
 * @param res             Resonance of the filter. Resonance is minimal at `0.0` and high at `1.0`,
 *                        above which the filter starts overdrive and sound saturated (e.g. `1.2`).
 * @param gain            Linear gain applied to the input signal.
 * @param mode            The filter can be used in lowpass (`0`) or highpass (`1`) mode.
 * @param noise           Amount (amplitude) of noise added to the model.
 */
final case class DFM1(rate: Rate, in: GE, freq: GE, res: GE, gain: GE, mode: GE, noise: GE) extends UGenSource.SingleOut("DFM1") {
   protected def makeUGens: UGenInLike = unwrap(IIdxSeq(in.expand, freq.expand, res.expand, gain.expand, mode.expand, noise.expand))
   protected def makeUGen(_args: IIdxSeq[UGenIn]): UGenInLike = new UGen.SingleOut(name, rate, _args)
}